<template>
  <div class="login login-box">
    <div class="login-theme"></div>
    <div class="login-body" @keyup.enter="submit('loginForm')">
      <div class="login-title">
        <img v-if="schoolLogo" :src="schoolLogo" alt="学校logo" />
        <h1 v-else>知学知考</h1>
      </div>
      <div class="login-form">
        <el-form ref="loginForm" :model="loginModel" :rules="loginRules">
          <el-form-item prop="loginName">
            <el-input
              v-model.trim="loginModel.loginName"
              placeholder="请输入账号"
              name="username"
              clearable
            >
              <i class="icon icon-phone" slot="prefix"></i>
            </el-input>
          </el-form-item>
          <el-form-item prop="password">
            <el-input
              type="password"
              v-model.trim="loginModel.password"
              placeholder="请输入密码"
              clearable
            >
              <i class="icon icon-password" slot="prefix"></i>
            </el-input>
          </el-form-item>
          <el-form-item prop="code" v-if="smsCodeRequired">
            <div class="vlcode">
              <div class="vlcode-right">
                <el-button
                  style="width:100%;"
                  type="text"
                  @click="fetchSmsCode"
                  :disabled="isFetchingCode"
                  >+{{ codeContent }}</el-button
                >
              </div>
              <div class="vlcode-left">
                <el-input
                  v-model.trim="loginModel.code"
                  placeholder="请输入手机验证码"
                  name="code"
                  clearable
                >
                  <i class="icon icon-checkcode" slot="prefix"></i>
                </el-input>
              </div>
            </div>
          </el-form-item>
          <el-form-item prop="schoolCode"></el-form-item>
          <el-form-item>
            <el-button
              class="login-submit-btn"
              size="large"
              type="info"
              :disabled="isSubmit"
              round
              @click="submit('loginForm')"
              >登录</el-button
            >
          </el-form-item>
        </el-form>
      </div>
    </div>

    <!-- 修改密码 -->
    <reset-pwd
      :user-info="userInfo"
      ref="ResetPwd"
      @modified="resetPwdSuccess"
    ></reset-pwd>
  </div>
</template>

<script>
import { password, smscode } from "@/plugins/formRules";
import { login, getSmsCode, getSchoolInfo, getSysConfig } from "../api";
import { Base64 } from "@/plugins/crypto";
import ResetPwd from "@/modules/base/components/ResetPwd";
import { ORG_CODE } from "@/constants/app";
import fetchSmsMixins from "../fetchSmsMixins";

export default {
  name: "login",
  components: { ResetPwd },
  mixins: [fetchSmsMixins],
  data() {
    return {
      nameWaitTime: "login",
      smsCodeRequired: false,
      loginModel: {
        schoolCode: ORG_CODE,
        loginName: "",
        code: "",
        password: ""
      },
      loginRules: {
        code: smscode,
        password,
        loginName: [
          {
            required: true,
            message: "请输入用户名",
            trigger: "change"
          }
        ],
        schoolCode: [
          {
            required: true,
            message: "学校编码缺失",
            trigger: "change"
          }
        ]
      },
      userInfo: {},
      roles: [],
      isSubmit: false,
      schoolLogo: ""
    };
  },
  mounted() {
    this.$ls.clear();
    this.setWaitingTime();
    this.getSchool();
    this.getSmsCodeRequired();
  },
  methods: {
    async getSmsCodeRequired() {
      const data = await getSysConfig("sys.code.enable");
      this.smsCodeRequired = data && data.configValue === "true";
    },
    async getSchool() {
      const data = await getSchoolInfo(ORG_CODE);
      this.$ls.set("schoolLogo", data.logo);
      this.$ls.set("schoolName", data.name);
      this.schoolLogo = data.logo;
    },
    async submit(name) {
      const valid = await this.$refs[name].validate().catch(() => {});
      if (!valid) return;

      if (this.isSubmit) return;
      this.isSubmit = true;
      const data = await login({
        loginName: this.loginModel.loginName,
        password: Base64(this.loginModel.password),
        code: this.smsCodeRequired ? this.loginModel.code : null,
        schoolCode: this.loginModel.schoolCode
      }).catch(() => {});
      this.isSubmit = false;
      if (!data) return;

      if (data.orgInfo)
        this.$ls.set("orgId", data.orgInfo.id, this.GLOBAL.authTimeout);
      if (data.schoolInfo)
        this.$ls.set("schoolId", data.schoolInfo.id, this.GLOBAL.authTimeout);
      this.$ls.set("user", data, this.GLOBAL.authTimeout);

      this.$ls.set("token", data.accessToken, this.GLOBAL.authTimeout);

      // 强制修改密码和绑定手机号
      if (
        data.userLoginCheckResult &&
        (!data.userLoginCheckResult.pwdCount ||
          !data.userLoginCheckResult.mobileNumber)
      ) {
        this.userInfo = {
          ...this.loginModel,
          ...data.userLoginCheckResult
        };
        this.$refs.ResetPwd.open();
        return;
      }

      if (data.roleList && data.roleList.includes("ADMIN")) {
        this.$router.push({
          name: "SelectSchool"
        });
      } else {
        this.$router.push({
          name: "Home"
        });
      }
    },
    resetPwdSuccess(data) {
      if (data.orgInfo)
        this.$ls.set("orgId", data.orgInfo.id, this.GLOBAL.authTimeout);
      if (data.schoolInfo)
        this.$ls.set("schoolId", data.schoolInfo.id, this.GLOBAL.authTimeout);
      this.$ls.set("user", data, this.GLOBAL.authTimeout);

      this.$ls.set("token", data.accessToken, this.GLOBAL.authTimeout);

      if (data.roleList && data.roleList.includes("ADMIN")) {
        this.$router.push({
          name: "SelectSchool"
        });
      } else {
        this.$router.push({
          name: "Home"
        });
      }
    },
    // code valid
    checkField(field) {
      return new Promise((resolve, reject) => {
        this.$refs.loginForm.validateField(field, unvalid => {
          if (unvalid) {
            reject();
          } else {
            resolve();
          }
        });
      });
    },
    async fetchSmsCode() {
      const validAll = [
        this.checkField("loginName"),
        this.checkField("password"),
        this.checkField("schoolCode")
      ];

      let result = true;
      await Promise.all(validAll).catch(() => {
        result = false;
      });

      if (!result) return;

      this.isFetchingCode = true;
      const data = await getSmsCode({
        loginName: this.loginModel.loginName,
        schoolCode: this.loginModel.schoolCode,
        password: Base64(this.loginModel.password)
      }).catch(() => {
        this.isFetchingCode = false;
      });
      if (!data) return;

      if (data.mobileNumber) {
        this.$message.success(
          `已向手机尾号【${data.mobileNumber.slice(
            -4
          )}】成功发送短信，请在2分钟内进行验证！`
        );
        this.changeContent();
      } else {
        this.isFetchingCode = false;
        this.$message.error("未绑定手机号，请先绑定！");
        this.userInfo = {
          ...data,
          loginName: this.loginModel.loginName,
          schoolCode: this.loginModel.schoolCode,
          password: this.loginModel.password
        };
        this.$refs.ResetPwd.open();
      }
    }
  }
};
</script>
